/**
 * name: use-spotlight@1.0.9
 * desc: A react hook that generates a animated 'spotlight' follows the active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as C, useRef as M, useCallback as N, useEffect as w } from "react";
var j = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function U(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
var W = "Expected a function", _ = 0 / 0, V = "[object Symbol]", G = /^\s+|\s+$/g, X = /^[-+]0x[0-9a-f]+$/i, Y = /^0b[01]+$/i, Z = /^0o[0-7]+$/i, H = parseInt, q = typeof j == "object" && j && j.Object === Object && j, J = typeof self == "object" && self && self.Object === Object && self, K = q || J || Function("return this")(), Q = Object.prototype, tt = Q.toString, et = Math.max, rt = Math.min, $ = function() {
  return K.Date.now();
};
function nt(t, e, r) {
  var o, a, p, c, l, d, u = 0, T = !1, h = !1, m = !0;
  if (typeof t != "function")
    throw new TypeError(W);
  e = P(e) || 0, L(r) && (T = !!r.leading, h = "maxWait" in r, p = h ? et(P(r.maxWait) || 0, e) : p, m = "trailing" in r ? !!r.trailing : m);
  function S(n) {
    var y = o, E = a;
    return o = a = void 0, u = n, c = t.apply(E, y), c;
  }
  function O(n) {
    return u = n, l = setTimeout(s, e), T ? S(n) : c;
  }
  function i(n) {
    var y = n - d, E = n - u, A = e - y;
    return h ? rt(A, p - E) : A;
  }
  function b(n) {
    var y = n - d, E = n - u;
    return d === void 0 || y >= e || y < 0 || h && E >= p;
  }
  function s() {
    var n = $();
    if (b(n))
      return f(n);
    l = setTimeout(s, i(n));
  }
  function f(n) {
    return l = void 0, m && o ? S(n) : (o = a = void 0, c);
  }
  function g() {
    l !== void 0 && clearTimeout(l), u = 0, o = d = a = l = void 0;
  }
  function v() {
    return l === void 0 ? c : f($());
  }
  function x() {
    var n = $(), y = b(n);
    if (o = arguments, a = this, d = n, y) {
      if (l === void 0)
        return O(d);
      if (h)
        return l = setTimeout(s, e), S(d);
    }
    return l === void 0 && (l = setTimeout(s, e)), c;
  }
  return x.cancel = g, x.flush = v, x;
}
function it(t, e, r) {
  var o = !0, a = !0;
  if (typeof t != "function")
    throw new TypeError(W);
  return L(r) && (o = "leading" in r ? !!r.leading : o, a = "trailing" in r ? !!r.trailing : a), nt(t, e, {
    leading: o,
    maxWait: e,
    trailing: a
  });
}
function L(t) {
  var e = typeof t;
  return !!t && (e == "object" || e == "function");
}
function ot(t) {
  return !!t && typeof t == "object";
}
function st(t) {
  return typeof t == "symbol" || ot(t) && tt.call(t) == V;
}
function P(t) {
  if (typeof t == "number")
    return t;
  if (st(t))
    return _;
  if (L(t)) {
    var e = typeof t.valueOf == "function" ? t.valueOf() : t;
    t = L(e) ? e + "" : e;
  }
  if (typeof t != "string")
    return t === 0 ? t : +t;
  t = t.replace(G, "");
  var r = Y.test(t);
  return r || Z.test(t) ? H(t.slice(2), r ? 2 : 8) : X.test(t) ? _ : +t;
}
var at = it;
const lt = /* @__PURE__ */ U(at), z = [0, 0, 0, 0], R = { x: 0, y: 0, width: 0, height: 0 }, ct = {
  throttleWait: 0,
  stageBorderEdge: !1,
  stageMutation: !1,
  lightPseudo: null
}, k = {
  content: '""',
  display: "block",
  boxSizing: "border-box",
  position: "absolute",
  top: "0px",
  left: "0px",
  width: "var(--spotlight-w)",
  height: "var(--spotlight-h)",
  transform: "translate(var(--spotlight-x), var(--spotlight-y))",
  transitionProperty: "transform, width, height",
  transitionDuration: "var(--spotlight-duration, 200ms)",
  background: "var(--spotlight-bg, rgba(255, 0, 0, 0.1))",
  pointerEvents: "none",
  zIndex: "999",
  padding: "0px",
  margin: "0px",
  overflow: "hidden"
}, ut = Object.keys(k).reduce((t, e) => {
  const r = e.replace(/([A-Z])/, "-$1").toLowerCase(), o = k[e];
  return `${t}${r}:${o};`;
}, ""), I = "spotlight-stage", B = (t, e) => {
  var r;
  try {
    return +(((r = getComputedStyle(t, null)) == null ? void 0 : r.getPropertyValue(e)) ?? "").replace("px", "");
  } catch {
    return 0;
  }
}, D = (t, e) => {
  const r = (t == null ? void 0 : t.getBoundingClientRect()) ?? R, o = e ? B(t, "border-left-width") : 0, a = e ? B(t, "border-top-width") : 0;
  return {
    ...r,
    x: r.x - ((t == null ? void 0 : t.scrollLeft) ?? 0) + o,
    y: r.y - ((t == null ? void 0 : t.scrollTop) ?? 0) + a
  };
}, F = ([t, e, r, o]) => ({
  "--spotlight-x": `${t}px`,
  "--spotlight-y": `${e}px`,
  "--spotlight-w": `${r}px`,
  "--spotlight-h": `${o}px`
}), dt = (t) => {
  const { throttleWait: e, stageBorderEdge: r, stageMutation: o, lightPseudo: a } = {
    ...ct,
    ...t
  }, [p, c] = C(z), [l, d] = C(R), [u, T] = C(R);
  let h = M(null), m = M(null);
  const S = N(
    (i) => {
      h.current = i, d(i ? D(i, r) : R);
    },
    [d, r]
  ), O = N(
    (i) => {
      m.current = i, T((i == null ? void 0 : i.getBoundingClientRect()) ?? R);
    },
    [T]
  );
  return w(() => {
    c([
      u.x - l.x,
      u.y - l.y,
      u.width,
      u.height
    ]);
  }, [l, u, c]), w(() => {
    const i = h.current, b = m.current;
    if (!i || !b)
      return () => c(z);
    let s = null, f = null;
    const g = lt(() => {
      const x = D(i, r), n = b.getBoundingClientRect();
      c([n.x - x.x, n.y - x.y, n.width, n.height]);
    }, e), v = () => {
      g();
    };
    return typeof ResizeObserver < "u" && (s = new ResizeObserver(g), s.observe(i), s.observe(b)), typeof MutationObserver < "u" && (f = new MutationObserver(v), o && f.observe(i, {
      subtree: !0,
      childList: !0
    }), f.observe(b, {
      subtree: !0,
      childList: !0,
      characterData: !0
    })), () => {
      s == null || s.disconnect(), f == null || f.disconnect();
    };
  }, [l, u, c, e, r, o]), w(() => {
    var f;
    const i = h.current;
    if (!i)
      return () => {
      };
    const b = i.style.position;
    i.style.position = "relative";
    let s = null;
    if (a && typeof document < "u") {
      s = document.createElement("style"), s.textContent = `.${I}${a} {${ut}}`, (f = document.head) == null || f.appendChild(s), i.classList.add(I);
      const g = F(p);
      Object.keys(g).forEach(
        (v) => i.style.setProperty(v, g[v])
      );
    }
    return () => {
      var g;
      i.style.position = b, a && typeof document < "u" && (i.classList.remove(I), s && ((g = document.head) == null || g.removeChild(s)));
    };
  }, [p, a]), {
    stage: S,
    actor: O,
    style: { ...F(p), ...k },
    size: p
  };
}, gt = null;
export {
  gt as default,
  dt as useSpotlight
};
